---
# DisableFormat: false
---
## See https://clang.llvm.org/docs/ClangFormatStyleOptions.html
### GLOBAL ###
Language: Cpp
Standard: Cpp11
BasedOnStyle: Google

### ALIGNMENTS ###
AlignAfterOpenBracket: Align
AlignConsecutiveAssignments: false
AlignConsecutiveDeclarations: false
AlignEscapedNewlines: Left
AlignOperands: false
AlignTrailingComments: true

AllowAllArgumentsOnNextLine: false
AllowAllParametersOfDeclarationOnNextLine: false

PointerAlignment: Right
DerivePointerAlignment: false

### Short lines ###
AllowShortBlocksOnASingleLine: Empty
AllowShortCaseLabelsOnASingleLine: true
AllowShortFunctionsOnASingleLine: None
AllowShortIfStatementsOnASingleLine: Never
AllowShortLoopsOnASingleLine: false

AlwaysBreakAfterDefinitionReturnType: None
AlwaysBreakAfterReturnType: None
AlwaysBreakBeforeMultilineStrings: false

BinPackArguments: true
BinPackParameters: false

### Breaking ###
ColumnLimit: 80
BreakBeforeBraces: Custom
BraceWrapping: # close to Allman style
  IndentBraces: false
  AfterCaseLabel: true
  AfterControlStatement: Always
  AfterFunction: true
  SplitEmptyFunction: false
  AfterEnum: true
  AfterStruct: true
  AfterUnion: true
  SplitEmptyFunction: false
  SplitEmptyRecord: false
  AfterExternBlock: false
  BeforeElse: true

BreakBeforeBinaryOperators: None
BreakBeforeTernaryOperators: false
BreakStringLiterals: true

### Indent ###
UseTab: Never
IndentWidth: 2
ContinuationIndentWidth: 2
IndentCaseLabels: false
IndentPPDirectives: None
IndentWrappedFunctionNames: true
ReflowComments: true

### SORTING ###
# includes are automatically grouped and sorted
IncludeBlocks: Regroup
IncludeCategories:
  # internal global includes
  - Regex: '^<.+\.h?>$'
    Priority: 1
  # local includes
  - Regex: '^".+\.h"$'
    Priority: 2
IncludeIsMainRegex: '$'
SortIncludes: true

### SPACES ###
SpaceAfterCStyleCast: true
SpaceAfterLogicalNot: false
SpaceBeforeAssignmentOperators: true
SpaceBeforeParens: ControlStatements
SpaceInEmptyBlock: false
SpaceInEmptyParentheses: false
SpacesBeforeTrailingComments: 1
SpacesInCStyleCastParentheses: false
SpacesInContainerLiterals: true
SpacesInParentheses: false
SpacesInSquareBrackets: false

### EMPTY LINES ###
KeepEmptyLinesAtTheStartOfBlocks: false
MaxEmptyLinesToKeep: 1

### Penalties ###
PenaltyBreakAssignment: 100
PenaltyBreakBeforeFirstCallParameter: 10
PenaltyBreakComment: 100
PenaltyBreakFirstLessLess: 0
PenaltyBreakString: 100
PenaltyExcessCharacter: 40
PenaltyReturnTypeOnItsOwnLine: 1000

### Mix ###
MacroBlockBegin: "CPPUNIT_NS_BEGIN"
MacroBlockEnd: "CPPUNIT_NS_END"
---
